package LFnet::CE;

BEGIN {
    use Exporter   ();
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);

               # set the version for version checking
    $VERSION     = 1.00;
               # if using RCS/CVS, this may be preferred
    $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /(\d+)/g;

    @ISA         = qw(Exporter);
    @EXPORT      = qw(&urlDecode);
    %EXPORT_TAGS = ( );     # eg: TAG => [ qw!name1 name2! ],

               # your exported package globals go here,
               # as well as any optionally exported functions
    @EXPORT_OK   = qw(&urlDecode);
}
our @EXPORT_OK;



sub urlDecode {
    my ($o) = @_;

    $o->{ce} = {}; # Marker fuer "durch CE-Decode bearbeitet"

    my ($prefix, $parameterToBeDecoded, $parameterUnencoded) = ($o->{req} =~ m/(.*iris.*?)\?(.*?)\&\&(.*)/);
    if (!defined($prefix)) {
	return(undef);
    }

    my @allow_parameter = qw(pov imgt query);
    my $parameterUnencodedParsed = "";

    $parameterUnencoded =~ s/\s+HTTP.*$//;

    foreach my $parameter (@allow_parameter) {
	if ($parameterUnencoded =~ m/$parameter/i) {
	    my ($pair) = $parameterUnencoded =~ m/($parameter=.*?)(\&|$)/i;
	    $parameterUnencodedParsed = $parameterUnencodedParsed . "&" . $pair;
	}
    }


    my $decodingResult = decodeParameter($parameterToBeDecoded);

    if (0) {
	print "prefix:                   $prefix\n";
	print "parameterToBeDecoded:     $parameterToBeDecoded\n";
	print "parameterUnencoded:       $parameterUnencoded\n";
	print "parameterUnencodedParsed: $parameterUnencodedParsed\n";
	print "decodingResult:           $decodingResult\n";
    }

    my @par;
    push(@par, split(/&/,$decodingResult,0));
    push(@par, split(/&/,$parameterUnencoded,0));

#    print "par: " . join("|",@par) . "\n"; # DEBUG

    foreach my $p (@par) {
	my ($k, $v) = ($p =~ /^([^\=]+)\=(.*)$/);
	if (!$k) {
	    print "empty key found in: $decodingResult, '$p'\n";
	    next;
	}
#	print "$k=$v\n"; # DEBUG
	$o->{ce}->{$k} = $v;
    }

#
#    if (0) {
#	foreach my $k ("SA","POV") {
#	    my @a = split(/,/,$o->{ce}->{$k},0);
#	    $o->{ce}->{$k} = \@a;
#	}
#    }
}




sub decodeParameter {
	my $parameter = uri_unescape($_[0]);

	my $strCodingCharset   = "pCmf0b9ec1iTVLruzhEBIDsXw46qan37%lAQWUJZgSRHoNKy25kdGOFPtx8MjvY";
	my $codeLength = 63;

	my $result = "";

	my $iPos = substr($parameter,12,2);
	my $iStepping = substr($parameter,14,2);

	my $l = length($parameter);

	for (my $i = 16; $i < $l; $i++) {
	    my $index = index($strCodingCharset, substr($parameter,$i,1)) - $iPos;

	    if ($index < 0) {
		$index -= (int($index / $codeLength ) - 1) * $codeLength;
	    }

	    $result .= substr($strCodingCharset,$index % $codeLength,1);
	    $iPos += $iStepping;
	}

	return(uri_unescape($result));
}



sub uri_unescape {
    my ($str) = @_;
    $str =~ s/%(\w{2})/chr(hex($1))/ge;
    return($str);
}

1;
