#
# $Id: RvSubDbi.pm,v 1.9 2004-05-26 10:20:39 rodney Exp $
#
#
#


#-----------------------------------------------------------------------------
package RvSubDbi;
use strict;
use DBI;
use vars qw(@ISA);
@ISA = qw(DBI);


# FIXME, do we need the init_rootclass() call here?
# __PACKAGE__->init_rootclass; # More general approach.






# ------------------------------------------------------------------
package RvSubDbi::db;
use vars qw(@ISA);
@ISA = qw(DBI::db);



sub pingx
{
    print "pingx\n";
}

sub table_attributes
{
    die("RvSubDbi::table_attributes() must be overloaded.\n");
}


# Parameter:
#
#      {
#	COLUMN_NAME => "description",
#	DATA_TYPE => $dtype->{code}, # DBI-Typename
#	NOTNULL => 1 | 0,
#	SCALE => $scale,
#	PRECISION => $prec
#      }
#
sub createLine
{
    my ($self, $h) = @_;

    my $cmd;

    my $dtype = $self->PlatformType($h->{DATA_TYPE});

    $cmd .= $self->fieldQuote($h->{COLUMN_NAME}) . " ";
    $cmd .= $dtype->{name};
    
    if ($h->{PRECISION})
    {
	$cmd .= " (" . $h->{PRECISION};

	if ($h->{SCALE})
	{
	    $cmd .= "," . $h->{SCALE};
	}
	$cmd .= ")";
    }

    if ($h->{NOTNULL})
    {
	$cmd .= " NOT NULL";
    }

    return($cmd);
}


sub fieldQuote
{
    my ($self,$n) = @_;

    # Default: no quoting.
    return($n);
}



# Parameter:
#
#      {
#	COLUMN_NAME => "description",
#	DATA_TYPE => $dtype->{code}, # DBI-Typename
#	NOTNULL => 1 | 0,
#	SCALE => $scale,
#	PRECISION => $prec
#      }
#
sub selectLine
{
    my ($self,$h) = @_;

    my $cmd;

    return($h->{COLUMN_NAME});
}



sub insertLine
{
    my ($self,$h) = @_;

    return('?');
}




# ------------------------------------------------------------------
package RvSubDbi::st;
use vars qw(@ISA);
@ISA = qw(DBI::st);






